﻿Imports System.Runtime.InteropServices
Imports System.Text

Module mdlHnd

    '****************************************************************************
    '****************************************************************************
    '**                                                                        **
    '**                  Copyright ©2010-2011 IM-Integrations                  **
    '**          All Rights Reserved, http://www.im-integrations.com/          **
    '**                    mailto:autopilot@locohacker.net                     **
    '**                                                                        **
    '****************************************************************************
    '****************************************************************************
    '**                                                                        **
    '** You are free to use this code within your own applications, but you    **
    '** are expressly forbidden from selling or otherwise profitting from this **
    '** source code, non-compiled, without prior written consent.              **
    '**                                                                        **
    '****************************************************************************
    '****************************************************************************

#Region "APIs & Delegates"

    'Some Delegates for CallBack functionality
    Private Delegate Function EnumWindowsProc(ByVal hWnd As IntPtr, ByRef data As SearchData) As Boolean
    Private Delegate Function EnumChildProc(ByVal hWnd As IntPtr, ByRef data As SearchData) As Int32

    'Imported Api's
    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
    Private Function EnumWindows(ByVal callback As EnumWindowsProc, ByVal extraData As IntPtr) As Boolean
    End Function
    <DllImport("user32.dll")> _
    Private Function EnumWindows(ByVal callback As EnumWindowsProc, ByRef data As SearchData) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    <DllImport("user32")> _
    Private Function EnumChildWindows(ByVal hwndParent As IntPtr, ByVal lpEnumFunc As [Delegate], ByRef data As SearchData) As Integer
    End Function
    <DllImport("user32")> _
    Private Function EnumChildWindows(ByVal hwndParent As IntPtr, ByVal lpEnumFunc As [Delegate], ByVal lParam As Integer) As Integer
    End Function
    <DllImport("user32")> _
    Public Function FindWindow(ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr
    End Function
    <DllImport("user32")> _
    Private Function GetClassName(ByVal hwnd As IntPtr, ByVal lpClassName As StringBuilder, ByVal nMaxCount As Integer) As Integer
    End Function
    <DllImport("user32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> _
    Public Function GetWindowText(ByVal hWnd As IntPtr, ByVal lpString As StringBuilder, ByVal nMaxCount As Integer) As Integer
    End Function

#End Region

#Region "Public Calls"

    Public Function FindMainWindow(ByVal wndclass As String, ByVal title As String) As IntPtr
        'Set our SearchData
        Dim sd As New SearchData()
        With sd
            'Set Class
            .sWinClass = wndclass
            'Set Caption
            .sTitle = title
            'Zero Handle
            .hWnd = IntPtr.Zero
        End With
        'Enum top level windows
        EnumWindows(New EnumWindowsProc(AddressOf EnumProc), sd)
        'Return Window Handle
        Return sd.hWnd
    End Function

    Public Function GetChild(ByVal MainClass As String, ByVal MainCaption As String, ByVal ChildClass As String, ByVal ChildIndex As Integer) As IntPtr
        'Get Handle Of Main Window
        Dim iMain As IntPtr = FindMainWindow(MainClass, MainCaption)
        'Only continue if Main window found
        If iMain <> IntPtr.Zero Then
            'Set our ChildData 
            Dim cd As New SearchData()
            With cd
                'Set target class
                .sWinClass = ChildClass
                'Set target index
                .iWinIndex = ChildIndex
                'Zero current index
                .iCurIndex = 0
                'Zero Handle
                .hWnd = IntPtr.Zero
            End With
            ' Setup new enum
            Dim myEnumChildProc As New EnumChildProc(AddressOf EnumChild)
            ' Enum childwindows
            EnumChildWindows(iMain, myEnumChildProc, cd)
            'Return window handle
            Return cd.hWnd
        End If
        'return Zero
        Return IntPtr.Zero
    End Function

    Public Function GetChild(ByVal ParentHandle As IntPtr, ByVal ChildClass As String, ByVal ChildIndex As Integer) As IntPtr
        'Only process if provided handle is not Zero
        If ParentHandle <> IntPtr.Zero Then
            'Set our ChildData
            Dim cd As New SearchData()
            With cd
                'Set target class
                .sWinClass = ChildClass
                'Set target index
                .iWinIndex = ChildIndex
                'Zero current index
                .iCurIndex = 0
                'Zero Handle
                .hWnd = IntPtr.Zero
            End With
            ' Setup new enum
            Dim myEnumChildProc As New EnumChildProc(AddressOf EnumChild)
            ' Enum childwindows
            EnumChildWindows(ParentHandle, myEnumChildProc, cd)
            'Return window handle
            Return cd.hWnd
        End If
        'return Zero
        Return IntPtr.Zero
    End Function

#End Region

#Region "Private Objects"

    ' This will hold vars for finding the target...
    Private Class SearchData
        ' Window Caption
        Public sTitle As String
        ' Window Class
        Public sWinClass As String
        ' Window Index from starting object
        Public iWinIndex As Integer
        ' Current index
        Public iCurIndex As Integer
        ' Handle of Window
        Public hWnd As IntPtr
    End Class

    Private Function EnumProc(ByVal hWnd As IntPtr, ByRef data As SearchData) As Boolean
        ' Check classname and title 
        ' This is different from FindWindow() in that the code below allows partial matches
        Dim sb As New StringBuilder(1024)
        GetClassName(hWnd, sb, sb.Capacity)
        'Use .Contains to allow partial Class match
        'If sb.ToString().Contains(data.sWinClass) Then
        'Use = to require perfect Class match
        If sb.ToString() = data.sWinClass Then
            sb = New StringBuilder(1024)
            GetWindowText(hWnd, sb, sb.Capacity)
            'Use .Contains to allow partial Caption match
            If sb.ToString().Contains(data.sTitle) Then
                'Use = to require perfect Caption match
                'If sb.ToString() = data.sTitle Then
                data.hWnd = hWnd
                ' Found the wnd, halt enumeration
                Return False
            End If
        End If
        ' Continue Enum
        Return True
    End Function

    'Call back for EnumChildWindows
    Private Function EnumChild(ByVal hWnd As IntPtr, ByRef data As SearchData) As Int32
        Dim ClassName As New StringBuilder(1024)
        ' Get the Child class name
        GetClassName(hWnd, ClassName, ClassName.Capacity)
        'Compair if its the class name we are looking for
        'Use .Contains to allow partial Class match
        'If ClassName.ToString().Contains(data.sWinClass) Then
        'Use = to require perfect Class match
        If ClassName.ToString() = data.sWinClass Then
            ' Class found - Increase Current Index by 1
            data.iCurIndex += 1
            ' Check if class is at correct index
            If data.iWinIndex = data.iCurIndex Then
                data.hWnd = hWnd
                'Stop Enum
                Return 0
            End If
        End If
        'Continue Enum
        Return 1
    End Function

#End Region

End Module
